package org.wfc.omada.api.hotspot.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * SelectIdsOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:35:35.496+08:00[Asia/Shanghai]")

public class SelectIdsOpenApiVo   {
  @JsonProperty("type")
  private Integer type;

  @JsonProperty("ids")
  @Valid
  private List<String> ids = null;

  @JsonProperty("groupId")
  private String groupId;

  @JsonProperty("searchKey")
  private String searchKey;

  @JsonProperty("status")
  private Integer status;

  public SelectIdsOpenApiVo type(Integer type) {
    this.type = type;
    return this;
  }

  /**
   * Select type. It should be a value as follows: 0: Represents selecting all vouchers in the voucher group, this selection does not pass parameter [ids]. 1: Parameter [ids] includes the IDs of vouchers in the voucher group to be selected. 2: Parameter [ids] includes the IDs of vouchers in the voucher group not to be selected
   * @return type
  */
  @ApiModelProperty(required = true, value = "Select type. It should be a value as follows: 0: Represents selecting all vouchers in the voucher group, this selection does not pass parameter [ids]. 1: Parameter [ids] includes the IDs of vouchers in the voucher group to be selected. 2: Parameter [ids] includes the IDs of vouchers in the voucher group not to be selected")
  @NotNull


  public Integer getType() {
    return type;
  }

  public void setType(Integer type) {
    this.type = type;
  }

  public SelectIdsOpenApiVo ids(List<String> ids) {
    this.ids = ids;
    return this;
  }

  public SelectIdsOpenApiVo addIdsItem(String idsItem) {
    if (this.ids == null) {
      this.ids = new ArrayList<>();
    }
    this.ids.add(idsItem);
    return this;
  }

  /**
   * ID list of vouchers. Voucher can be created using 'Create Voucher Group' interface, and Voucher ID can be obtained from 'Get Voucher Group Detail' interface
   * @return ids
  */
  @ApiModelProperty(value = "ID list of vouchers. Voucher can be created using 'Create Voucher Group' interface, and Voucher ID can be obtained from 'Get Voucher Group Detail' interface")


  public List<String> getIds() {
    return ids;
  }

  public void setIds(List<String> ids) {
    this.ids = ids;
  }

  public SelectIdsOpenApiVo groupId(String groupId) {
    this.groupId = groupId;
    return this;
  }

  /**
   * Voucher Group ID. Voucher group can be created using 'Create Voucher Group' interface, and Voucher Group ID can be obtained from 'Get Voucher Group list' interface
   * @return groupId
  */
  @ApiModelProperty(required = true, value = "Voucher Group ID. Voucher group can be created using 'Create Voucher Group' interface, and Voucher Group ID can be obtained from 'Get Voucher Group list' interface")
  @NotNull


  public String getGroupId() {
    return groupId;
  }

  public void setGroupId(String groupId) {
    this.groupId = groupId;
  }

  public SelectIdsOpenApiVo searchKey(String searchKey) {
    this.searchKey = searchKey;
    return this;
  }

  /**
   * Fuzzy query parameters, support field: voucher code
   * @return searchKey
  */
  @ApiModelProperty(value = "Fuzzy query parameters, support field: voucher code")


  public String getSearchKey() {
    return searchKey;
  }

  public void setSearchKey(String searchKey) {
    this.searchKey = searchKey;
  }

  public SelectIdsOpenApiVo status(Integer status) {
    this.status = status;
    return this;
  }

  /**
   * voucher status filter query parameters. It should be a value as follows: 0: Unused vouchers, 1: In use vouchers, 2: Expired vouchers
   * @return status
  */
  @ApiModelProperty(value = "voucher status filter query parameters. It should be a value as follows: 0: Unused vouchers, 1: In use vouchers, 2: Expired vouchers")


  public Integer getStatus() {
    return status;
  }

  public void setStatus(Integer status) {
    this.status = status;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SelectIdsOpenApiVo selectIdsOpenApiVo = (SelectIdsOpenApiVo) o;
    return Objects.equals(this.type, selectIdsOpenApiVo.type) &&
        Objects.equals(this.ids, selectIdsOpenApiVo.ids) &&
        Objects.equals(this.groupId, selectIdsOpenApiVo.groupId) &&
        Objects.equals(this.searchKey, selectIdsOpenApiVo.searchKey) &&
        Objects.equals(this.status, selectIdsOpenApiVo.status);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, ids, groupId, searchKey, status);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SelectIdsOpenApiVo {\n");
    
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    ids: ").append(toIndentedString(ids)).append("\n");
    sb.append("    groupId: ").append(toIndentedString(groupId)).append("\n");
    sb.append("    searchKey: ").append(toIndentedString(searchKey)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

